﻿using System;
using System.Linq;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace CrystalOfInsanity {
    public class CrystalOfInsanityPlugin : HBPlugin {
	
        public static LocalPlayer Me = StyxWoW.Me;

        public static WoWItem CrystalOfInsanityItem;
		
        public override string Name {
            get { return "Crystal Of Insanity"; }
        }

        public override string Author {
            get { return "Wigglez"; }
        }

        public override Version Version {
            get { return new Version(1, 1); }
        }

        public override void OnEnable() {
            CustomNormalLog("Initialization complete.");
            
            base.OnEnable();
        }

        public override void OnDisable() {
            CustomNormalLog("Shutdown complete.");

            base.OnDisable();
        }

        public override void Pulse() {
            if(!HasCrystalOfInsanityItem()) {
                return;
            }

            if(!CanUseCrystalOfInsanity()) {
                return;
            }

            if(HasCrystalOfInsanityBuff()) {
                return;
            }

            if(IsCrystalOfInsanityOnCooldown()) {
                return;
            }

            UseCrystalOfInsanity();

            CustomNormalLog("Crystal of Insanity buff is now active.");
        }

        public void CustomNormalLog(string message, params object[] args) {
            Logging.Write(Colors.DeepSkyBlue, "[Crystal of Insanity]: " + message, args);
        }

        public static bool IsViable(WoWObject pWoWObject) {
            return (pWoWObject != null) && pWoWObject.IsValid;
        }

        public static bool HasCrystalOfInsanityItem() {
            CrystalOfInsanityItem = Me.BagItems.FirstOrDefault(item => item.Entry == 86569);

            return CrystalOfInsanityItem != null;
        }

        public static bool CanUseCrystalOfInsanity() {
            return IsViable(Me) && !Me.Mounted && !Me.IsDead && !Me.InVehicle && !Me.IsChanneling && !Me.IsFlying && !Me.IsCasting && !Me.OnTaxi;
        }

        public static bool HasCrystalOfInsanityBuff() {
            return Me.HasAura(127230);
        }

        public static void UseCrystalOfInsanity() {
            CrystalOfInsanityItem.Use();
        }

        public static bool IsCrystalOfInsanityOnCooldown() {
            return CrystalOfInsanityItem.Cooldown > 0;
        }
    }
}